#!/usr/local/bin/perl5 -w
# -*- Perl -*-
#
# tiny_mknmz.cgi (pnamazu-2002.11.16) - cgi program to make index
#         by furukawa@tcp-ip.or.jp
# tiny_mknmz.cgi (pnamazu-2006.02.28) - cgi program to make index
#         by yw3t-trns@asahi-net.or.jp
#
use strict;

## ɬܤ
##   ϡ桼δĶ˹碌ѹ뤳ȤɬܤǤ

# оݥƥĤκǤ̤Υǥ쥯ȥ URL
my $top_url = '';

# Υǥ쥯ȥΥե륷ƥǤ̾
my $top_dir = '';

# ǥå֤ǥ쥯ȥ̾
# (񤭹ߤĤƤɬפޤ)
my $index_dir = '';

# ե֤ǥ쥯ȥ̾
# (񤭹ߤĤƤɬפޤ)
my $tmp_dir = '';

# ɤǡꤷƤ
my $show_warning = 1;

# 餫ͳˤꡢŵưפʤɤξ֤ȴʤ
# ʤä硢1 ˤƤ
my $cleanup = 0;


## ϥѡƥѤ

# cgi, config.ph Τǥ쥯ȥΥե륷ƥǤ̾
my $hns_dir = '';


## ɬܤǤʤ

# ץ (namazu.cgi, pnamazu.cgi) ֤ǥ쥯ȥ
# (񤭹ߤĤƤС.namazurc ưޤ)
my $nmz_dir = '';

# оݤ鳰ǥ쥯ȥΥꥹ
# 줬ξϡ$top_dir ʲǥ쥯ȥ򸡺ޤ
my @deny_dirs = ();


## ʲѿϡͤȤơŪͤƤޤ
## ưѹˡԽƤ

#  ()
# λ֤вᤷ顢Υեɤޤ˽λ˰ܤ롣
# ֤ǥץߤ륵ФʤɤͭѤ
# λ⤽ʤλ֤Τǡʬ򸫤
# ˤȤ褤
my $alarmtime = 150;

# ǥåǽ餫ľ硢0 ˤƤ
my $update = 1;

# 礭եϸоݤȤʤ
my $size_limit = 50000;

# mail header  html  meta, title 򸡺оݤȤʤСνŤ
my %weight = ('title' => 10,
              'subject' => 10,
              'keyword' => 10,
              'description' => 10);


# summary ʤФΥ (bytes)
my $summary = 200;

# եɤΥꥹ
# subject, uri, size ˤĤƤϡǻꤷʤƤޤ
# summary ˤĤƤϡ $summary ѿǷޤޤ
my @field = ('from', 'subject', 'uri', 'size');
my %field_alias = ('author' => 'from', 'title' => 'subject',
                   'description' => 'summary');

# оݥեΥѥ (ɽ)
my @target_list =
    (
     {'type' => 'html', 'proc' => \&html, 'pattern' => "\\.s?html?\$"},
     {'type' => 'mail', 'proc' => \&mail, 'pattern' => "\\/\\d+\$"},
     {'type' => 'text', 'proc' => \&text, 'pattern' => "\\.(text|txt)\$"},
     {'type' => 'diary', 'proc' => \&diary, 'pattern' => "d\\d{8}\\.hnf\$"},
     );

# ǥХåϤ򤹤뤫
my $DEBUG = 0;

# ͥ٤򲼤 (礭ۤͥ٤롣0-19 )
my $priority = 0;

##
##  
##

use DirHandle;
use IO::File;

open(STDERR, ">&STDOUT");
STDOUT->autoflush(1);
STDERR->autoflush(1);

push(@INC, $1) if $0 =~ /^(.+)\/[^\/]+$/;
require 'iocode.pl';
require 'nmzidx.pl';

my %html2plain = ('&gt;' => '>',
                  '&lt;' => '<',
                  '&quot;' => "'",
                  '&amp;' => '&',
                 );
my $html2plain = join('|', (sort {length $b <=> length $a} keys %html2plain));

map {$$_ =~ s/\/$// if $$_} (\$top_url, \$top_dir,
                             \$index_dir, \$tmp_dir,
                             \$hns_dir, 
                             \$nmz_dir);


my $katakana = '(?:[\xa5-\xa7][\xa1-\xfe]|\xa1\xbc)';
my $hiragana = '(?:\xa4[\xa1-\xfe])';
my $kanji = '(?:[\xb0-\xf4][\xa1-\xfe])';

my $alnum = "[a-zA-Z\\d_]";
my $connect = "[\\-\\/\\.\\=\\']";
my $alnum_word = "$alnum(?:$connect?$alnum)*";

my $need_to_indexing = 0;

my $nmzo;
my $nmzo_flist;
my %field;
my @file_list;
my $nmzi;
my %keep_path;

my $total_size = 0;
my %deny_dirs;
my %addition;

#  URL
my $hns_url;
# ǥ쥯ȥ
my $diary_dir;
my $diary_board_file;

$DEBUG = 1 if -e "debug";
$cleanup = 1 if -e "cleanup";

print "Content-Type: text/plain; charset=EUC-JP\n\n";

&debug::info("tiny_mknmz.cgi (pnamazu-2006.02.28)\n");

&debug::printenv;

if (defined $show_warning){
    print "ޤ (tiny_mknmz.html) ɤǡ򤷤Ƥ\n";
    exit;
}

&term if $cleanup;
$SIG{'TERM'} = \&term;
$SIG{'INT'} = \&term;

print("tmp_dir ˽񤭹ߤǤޤ\n"), exit unless -w $tmp_dir;
print("index_dir ˽񤭹ߤǤޤ\n"), exit unless -w $index_dir;

print("餯ŵưǤ\n"), exit unless mkdir("$tmp_dir/lock", 0777);
&debug::info("Locked.");

if ($priority){
    eval {
        &debug::debug("priority: " . getpriority(0, 0));
        setpriority(0, 0, $priority + getpriority(0, 0));
        &debug::debug("  -> " . getpriority(0, 0));
    };
}

&debug::info("alarmtime is $alarmtime sec.") if $alarmtime;

mkdir("$tmp_dir/word", 0777);
mkdir("$tmp_dir/phrase", 0777);

if (defined $hns_dir and -r "$hns_dir/config.ph"){
    &debug::info("_Error: $@") if $@;
    eval {require "$hns_dir/config.ph";
          ($hns_url = $HNS::System::MyDiaryURI) =~ s/\/$//
              if defined $HNS::System::MyDiaryURI;

          ($diary_dir = $HNS::System::DiaryDir) =~ s/\/$//
              if defined $HNS::System::DiaryDir;
          ($diary_board_file = $Board::BoardData) =~ s/\/$//
              if defined $Board::BoardData;
      };
    &debug::info("Error: $@") if $@;
    if (defined $diary_dir){
        if (defined $diary_board_file){
            my $fh = new IO::File $diary_board_file;
            &diary_board($fh) if defined $fh;
        }
    }
}

&prescan;

for my $deny_dir (@deny_dirs){
    $deny_dir =~ s/\/$//;
    $deny_dirs{$deny_dir} = 1;
}

if (defined $diary_dir){
    &debug::info("diary scan -- start");
    for my $entry (&dir_entry($diary_dir)){
        my $path = "$diary_dir/$entry";
        next unless $entry =~ /^\d{4}$/;
        next unless -d $path;
        &scan($path);
    }
    &debug::info("diary scan -- end");
}

if (defined $top_dir){
    &debug::info("directory scan -- start");
    &scan($top_dir);
    &debug::info("directory scan -- end");
}

&main;
&unlock;
&debug::info("time: " . (time - $^T) . "sec.");
&debug::ps;
exit;

# ʸ

sub diary_board{
    my $fh = shift;
    while (defined (my $line = $fh->getline)){
        chomp $line;
        my ($pass, $index, $reff, $diary, $any, $time, $title, $name, $mail, $url, $ip, $mes) = split(/\t/, $line);
        if ($diary =~ /^(\d{4})(\d{2}\d{2})\d+$/){
            my $path = "$diary_dir/$1/d$1$2.hnf";
            $addition{$path}->{'t'} = $time if !defined($addition{$path}) or $addition{$path}->{'t'} < $time;
            push(@{$addition{$path}->{'line'}}, $title);
            push(@{$addition{$path}->{'line'}}, $mes);
        }
    }
}

sub diary{
    my $fh = shift;
    my $ok = 0;

    if ($fh->{'path'} =~ /d(\d{4})(\d{2})(\d{2})\.hnf$/){
        my $year = $1;
        my $month = $2;
        my $day = $3;
        $fh->putfield('uri',
                      "$hns_url/\?$year$month"
                      . (($day <= 10)? 'a': (($day <= 20)? 'b': 'c'))
                      . '#' . "$1$2$3" . "0");
        $fh->putfield('subject', "$year/$month/$day");
    }

    if (defined $HNS::System::UserMail){
        $fh->putfield('from', $HNS::System::UserMail);
    }

    while (defined (my $line = $fh->getline)){
        $ok = 1, last if $line =~ /^OK$/;
    }
    return unless $ok;

    my $buf = '';
    my $weight = 1;

    my %hns_cmd =
        (
         'CAT' => -1, 'GRP' => -1,
         '\!' => 0,   '\!\#' => 0,
         'NEW' => 0,  'SUB' => 0,
         'GRP' => 0,  'STRIKE' => 0,
         'LNEW' => 1, 'LSUB' => 1,
         'LINK' => 1, 'URL' => 1,
         'SPAN' => 1, 'STRIKE' => 1,
         'RLINK' => 2, 'RLNEW' => 2,
         'RLSUB' => 2, 'FONT' => 2,
         'IMG' => 2,
         'LIMG' => 3,
         );
    my $hns_cmd_pattern = join('|', keys %hns_cmd);

    my $status = '';
    my $category = '';

    for (;;){
        my $line = $fh->getline;
        if (defined $line){
            my $cmd;
            $line =~ s/\~$/\n/;

            if ($line =~ s/^($hns_cmd_pattern)\b\s*//){
                $cmd = $1;
                my $cnt = 0;

                if (defined $hns_cmd{$cmd}){
                    $cnt = $hns_cmd{$cmd};
                    --$cnt while $cnt > 0 && $line =~ s/^(\S+)\s+//;
                }

                if (length $buf){
                    $buf .= "\n";
                    $fh->putsummary($buf);
                    $fh->putline(\$buf);
                }

                $category .= $line . " ", next if $cmd eq 'CAT';
                $status = 'GRP', next if $cmd eq 'GRP';

                if ($cmd eq 'NEW'){
                    if ($status = ($status eq 'GRP'? '': 'NEW')){
                        for my $key ($category =~ m/(\S+)/g){
                            $fh->putline("$key\n");
                        }
                        $fh->putline("$line\n");
                        $line = "\xa2\xa3$line\xa2\xa7";
                        $fh->putsummary($line);
                    }
                    $category = '';
                }elsif ($status){
                    $fh->putline("$line\n");
                    $fh->putsummary($line);
                }
                next;
            }

            if ($line =~ s/^(\/)?(CITE|PRE|FN|P|DIV|UL|OL|DL)//
                || $line =~ s/^(LI|DT|DD)\s+//){

                if (length $buf){
                    $buf .= "\n";
                    $fh->putsummary($buf);
                    $fh->putline(\$buf);
                }
            }
            next unless $status;
            $buf .= $line;
            next if $line =~ /$katakana$/;
            $line =~ s/\~$//;
        }
        $fh->putsummary($buf);
        $fh->putline(\$buf);
        last unless defined $line;
    }
    $fh->close;
}

sub html{
    my $fh = shift;
    my $htmlbuf = '';
    my $buf = '';

    my $in_title = 0;
    my $weight = 1;
    $fh->euc_option('');

    for (;;){
        my $line = $fh->getline;
        if (defined $line){
            $htmlbuf .= $line;
            while (length $htmlbuf){
                if ($htmlbuf =~ s/^([^\<]+)//){
                    my $str = $1;
                    $str =~ s/($html2plain)/$html2plain{$1}/g;
                    $str = &x0208alpha_to_ascii($str);
                    $buf .= $str;
                    if ($in_title){
                        $fh->putfield("title", $str);
                    }else{
                        $fh->putsummary($str);
                    }
                    $buf .= " " if $htmlbuf =~ /^</;
                }elsif ($htmlbuf =~ s/^<([^\>]*)>//){
                    my $tag = $1;
                    my $old_in_title = $in_title;

                    $in_title = ($tag =~ /^title/i);
                    if ($in_title != $old_in_title){
                        $buf .= "\n";
                        $fh->putline(\$buf, $weight);
                        if ($in_title){
                            $weight = $weight{'title'} if defined $weight{'title'};
                        }else{
                            $weight = 1;
                        }
                    }

                    if ($tag =~ s/^meta\s+//
                        && $tag =~ /name=\"([^\"]+)/i){ #"
                        my $name = $1;
                        if ($tag =~ /content=\"([^\"]+)/i){ #"
                            my $str = $1;
                            $str =~ s/($html2plain)/$html2plain{$1}/g;
                            $str = &x0208alpha_to_ascii($str);
                            $fh->putfield($name, $str);

                            if (defined $weight{$name}){
                                if (length $buf){
                                    $buf .= "\n";
                                    $fh->putline(\$buf, $weight);
                                }
                                $fh->putline("$str\n", $weight{$name});
                            }
                        }
                    }
                    next;
                }
                last;
            }
            next if $line =~ /$katakana$/;
        }
        $fh->putline(\$buf, $weight);
        last unless defined $line;
    }
    $fh->close;
}

sub text{
    my $fh = shift;
    my $buf = '';
    for (;;){
        my $line = $fh->getline;
        if (defined $line){
            $buf .= $line;
            next if $line =~ /$katakana$/;
        }
        $fh->putsummary($buf);
        $fh->putline(\$buf);
        last unless defined $line;
    }
    $fh->close;
}

sub mail{
    my $fh = shift;
    my $boundary = '';
    my $enable = 1;
    my $body = 1;
    my $buf = '';

    my @head = ();

    for (;;){
        my $line = $fh->getline;
        last unless defined $line;
        last if $line =~ /^$/;

        chomp $line;
        push(@head, $line), next if $line =~ /^\S/;

        last unless @head;
        $head[$#head] .= $line;
    }

    for my $head (@head){
        if ($head =~ s/^([^\s:]+):\s*//){
            my $field = $1;
            $fh->putfield($field, $head);
            if ($field =~ /^Subject$/i){
                $head =~ s/^\[.*?\]//;
                $head =~ s/\bre: *?//gi;
            }elsif ($field =~ /^Content-Type$/i){
                if ($head =~ /multipart.*boundary=\"([^\"]+)\"/i){ #"
                    $boundary = $1;
                }elsif ($head =~ /message\/partial/i){
                    $body = 0;
                }elsif ($head !~ /text\/plain/i){
                    &debug::info("$field: $head");
                    $enable = 0;
                }
            }elsif ($field =~ /^Content-Transfer-Encoding$/i){
                if ($head =~ /base64|quoted-printable/i){
                    &debug::info("$field: $head");
                    $enable = 0;
                }
            }
            $fh->putline("$head\n", $weight{$field}) if defined $weight{$field};
        }
    }
    @head = ();

    while ($enable){
        my $line = $fh->getline;

        if ($body){
            if (defined $line){
                my $sum = 1;
                if ($boundary){
                    $body = 0, next if $line =~ /--$boundary(--)?$/;
                    $line =~ s/This is multipart message.//i;
                }
                $sum = 0 while $line =~ s/^(\s*|[a-z0-9\-\._\xa1-\xfe]{,10})>\s*//i;
                $sum = 0 if $line =~ s/^\#\s*//;
                $buf .= $line;
                $fh->putsummary($line) if $sum;
                next if $buf =~ /$katakana$/;
                if ($line =~ /^M[\x21-\x60]{60}$/
                    || $line =~ /^begin [0-7]{3,4} \S+$/){
                    &debug::info("uuencode");
                    $enable = 0;
                }
                if ($line =~ /^\(This file must be converted with BinHex/){
                    &debug::info("BinHex");
                    $enable = 0;
                }
            }
            $fh->putline(\$buf);

        }elsif ($line =~ /^$/){
            for my $head (grep {/^Content-/} @head){
                if ($head =~ s/^([^\s:]+):\s*//){
                    my $field = $1;
                    if ($field =~ /^Content-Type$/i){
                        if ($head =~ /multipart.*boundary=\"([^\"]+)\"/i){ #"
                            $boundary = $1;
                        }elsif ($head !~ /text\/plain/i){
                            $enable = 0;
                            &debug::info("$field: $head");
                        }
                    }elsif ($field =~ /^Content-Transfer-Encoding$/i){
                        if ($head =~ /base64|quoted-printable/i){
                            $enable = 0;
                            &debug::info("$field: $head");
                        }
                    }
                }
            }
            $body = 1;
            @head = ();
        }else{
            chomp $line;
            push(@head, $line), next if $line =~ /^\S/;
            last unless @head;
            $head[$#head] .= $line;
        }
        last unless defined $line;
    }
    $fh->close;
}

# 

sub prescan{
    $nmzo = new nmzidx($index_dir, 'w');
    $nmzo_flist = $nmzo->open_flist;
    $nmzo_flist->{'field'} = new nmzfield;

    my @additional_field = ('subject', 'uri', 'size');
    push(@additional_field, 'summary') if $summary;
    for my $field (@additional_field){
        push(@field, $field) unless grep {$_ eq $field} @field;
    }
    for my $field (@field){
        $field{$field} = $field;
        $nmzo_flist->{'field'}->open($nmzo, $field);
    }
    for my $field (keys %field_alias){
        $field{$field} = $field_alias{$field} if defined $field{$field_alias{$field}};
    }

    my $nmzi;
    my $nmzi_flist;
    if ($update
        && -r "$index_dir/NMZ.t"
        && defined($nmzi = new nmzidx($index_dir, 'r'))
        && defined($nmzi_flist = $nmzi->open_flist)){

        &debug::info("index check -- start");

        $nmzi_flist->{'field'} = new nmzfield;
        for my $field (@field){
            $nmzi_flist->{'field'}->open($nmzi, $field);
        }

        my $total = $nmzi_flist->{'size'};

        my %list;
        my %table;
        my $entry_no = -1;
        while (defined $nmzi_flist->read(\%list)){
            my $path = $list{'r'};
            ++$entry_no;
            unless (-r $path){
                &debug::info("$path is deleted.");
                $need_to_indexing = 1;
                next;
            }
            if (&mtime($path) > $list{'t'}){
                &debug::info("$path is updated.");
                $need_to_indexing = 1;
                next;
            }
            $table{$entry_no} = $nmzo_flist->{'offset'};
            &debug::info("$path: $entry_no -> $table{$entry_no}");
            $keep_path{$path} = 1;
            $nmzo_flist->write(\%list);
        }

        &debug::info("checking word index");
        my $nmzi_word = $nmzi->open_word;
        $total = $nmzi_word->{'size'};
        my $word;
        my $fh;
        my $current_ord = '';
        while (defined $nmzi_word->read(\$word, \%list)){
            my $ord = sprintf("%02X", ord $word);
            for my $key (sort {$a <=> $b} keys %list){
                if (defined $table{$key}){
                    if ($current_ord ne $ord){
                        $current_ord = $ord;
                        $fh = new IO::File (">>$tmp_dir/word/_$ord");
                    }
                    $fh->printf("%s %04X %04X\n", $word, $table{$key}, $list{$key});
                }
            }
            &debug::progress("word: " . $nmzi_word->{'offset'} . "/$total");
        }
        $fh->close if $current_ord ne '';

        &debug::info("checking phrase index");
        my $current_entry = -1;
        my $nmzi_phrase = $nmzi->open_phrase;
        $total = $nmzi_phrase->{'size'};
        for (my $hash_h = 0; $hash_h < 0x100; ++$hash_h){
            for (my $hash_l = 0; $hash_l < 0x100; ++$hash_l){
                my @list;
                if (defined $nmzi_phrase->read(\@list)){
                    for my $key (@list){
                        if (defined $table{$key}){
                            if ($current_entry != $hash_h){
                                $current_entry = $hash_h;
                                $fh = new IO::File(sprintf(">>%s/phrase/_%02X", $tmp_dir, $current_entry));
                            }
                            $fh->printf("%02X%02X %04X\n", $hash_h, $hash_l, $table{$key});
                        }
                    }
                }
            }
            &debug::progress("phrase: " . $nmzi_phrase->{'offset'} . "/$total");
        }
        $fh->close if $current_entry >= 0;
        &debug::info("index check -- end");
    }else{
        $need_to_indexing = 1;
    }
}

sub main{
    &debug::info("no need to update."), return unless $need_to_indexing || @file_list;
    &nmzphrase::init_seed;
    &debug::info("phrase error\n") unless defined @nmzphrase::Seed;

    my $file_total = scalar @file_list;
    my $file_number = 0;
    for my $entry (@file_list){
        ++$file_number;
        next unless defined(my $fh = new userfile $entry);

        &code_reset;

        $total_size += $fh->{'size'};

        &debug::info("file: $file_number/$file_total (" . $fh->{'size'} . "/$total_size bytes) -- $entry");

        for my $ptr (@target_list){
            &{$ptr->{'proc'}}($fh), last if $entry =~ /$ptr->{'pattern'}/i
        }
        if ($alarmtime){
            &debug::info("Alarm time is arrived."), last if time > $^T + $alarmtime;
        }
    }
    $nmzo_flist->close;

    &debug::info("making word index");
    my $nmzo_word = $nmzo->open_word;
    for my $entry (&dir_entry("$tmp_dir/word", 's')){
        my $path = "$tmp_dir/word/$entry";
        if (-f $path && $entry =~ /^_([2-9A-F][\dA-F])$/i){
            my $ord = $1;
            if (defined (my $fh = new IO::File($path))){
                my @lines = sort $fh->getlines;
                while (@lines && $lines[0] =~ /^(\S+)/){
                    my $word = $1;
                    my %list;

                    my $head = "$word ";
                    my $len = length $head;

                    while (@lines
                           && $head eq substr($lines[0], 0, $len)){
                        my $line = shift(@lines);
                        chomp $line;
                        my ($w, $f, $s) = split(/\s+/, $line);
                        $list{hex $f} = hex $s;
                    }
                    $nmzo_word->write($word, \%list);
                }
                $fh->close;
                unlink $path;

                &debug::progress("  word: " . hex($ord) . "/256");
            }
        }
    }
    $nmzo_word->close;

    &debug::info("making phrase index");
    my $i = 0;
    my $nmzo_phrase = $nmzo->open_phrase;

    for my $entry (&dir_entry("$tmp_dir/phrase", 's')){
        my $path = "$tmp_dir/phrase/$entry";
        if (-f $path && $entry =~ /^_([\dA-F]+)$/i){
            if (defined(my $fh = new IO::File($path))){
                my @list = ();
                for my $line (sort $fh->getlines){
                    chomp $line;
                    my ($h, $f) = split(/\s+/, $line);
                    $h = hex $h;
                    if ($i < $h){
                        $nmzo_phrase->write(\@list);
                        $i++;
                        @list = ();
                        while ($i < $h){
                            $nmzo_phrase->write(\@list);
                            $i++;
                        }
                    }
                    push(@list, hex $f);
                }
                $nmzo_phrase->write(\@list);
                $i++;
            }
        }
        &debug::progress("  phrase: $i/65536");
    }
    while ($i < 0x10000){
        my @list = ();
        $nmzo_phrase->write(\@list);
        $i++;
    }
    $nmzo_phrase->close;

    unless (-f "$index_dir/NMZ.status"){
        my $fh = new IO::File(">$index_dir/NMZ.status");
        $fh->print("files 0\nkeys 0\n");
    }
    if (my $nmzi = new nmzidx($index_dir, 'r')){
        $nmzo->write_status($nmzi);
    }
    $nmzo->replace_db;

    unless (-f "$index_dir/NMZ.result.normal"){
        my $fh = new IO::File(">$index_dir/NMZ.result.normal");
        $fh->print("<dt>\${namazu::counter}. <strong><a href=\"\${uri}\">\${title}</a></strong> (score: \${namazu::score})\n");

        my @list = sort grep {!/^(size|subject|uri|summary)$/} keys %field;
        for my $field (@list){
            next if $field ne $field{$field};
            $fh->print("<dd><strong>\u$field</strong>: <em>\${$field}</em>\n");
        }
        $fh->print("<dd>\${summary}\n");
        $fh->print("<dd><a href=\"\${uri}\">\${uri}</a> (\${size} bytes)<br><br>\n");
    }

    my $fh;
    my $q_dir = quotemeta("$top_dir/") if defined $top_dir;
    if (defined ($fh  = new IO::File(">$nmz_dir/.namazurc"))){
        $fh->print("Lang ja\n");
        $fh->print("Index $index_dir/\n");
        $fh->print("Replace $q_dir $top_url/\n") if defined $top_dir;
        $fh->close;
    }
    if (defined ($fh  = new IO::File(">$nmz_dir/.pnamazurc"))){
        $fh->print("Lang ja\n");
        $fh->print("Index $index_dir/\n");
        $fh->print("Replace $q_dir $top_url/\n") if defined $top_dir;
        $fh->print("RespTextOrig 1\n");
        $fh->print("TinyMknmz 1\n");
        $fh->print("DiaryDir $diary_dir/") if defined $diary_dir;
        $fh->print("MakeSummary 1\n") unless $summary;
        $fh->close;
    }
    &debug::info("Success!");
}

sub scan{
    my $dir = shift;
    if (defined $deny_dirs{$dir}){
        &debug::info("$dir -- directory is denied");
        return;
    }
    for my $entry (&dir_entry($dir, 'n')){
        my $path = "$dir/$entry";
        next if $entry =~ /^(\.|NMZ)/;
        next if $path eq $tmp_dir;
        next if $path eq $index_dir;

        if (-d $path){
            &scan($path);
        }elsif (-f $path){
            next if defined $keep_path{$path};

            $keep_path{$path} = 1;

            my $match = undef;
            for my $ptr (@target_list){
                $match = $ptr, last if $path =~ /$ptr->{'pattern'}/i;
            }
            &debug::info("$path -- skipped by type"), next unless defined $match;

            my $size = -s $path;
            &debug::info("$path -- skipped by size"), next if $size == 0 || $size_limit < $size;
            
            push(@file_list, $path),
            &debug::info("$path -- " . $match->{'type'});
        }
    }
}

# ѽλط

sub mtime{
    my $path = shift;
    my $mtime = (stat($path))[9];
    if (defined($addition{$path})
        and defined($addition{$path}->{'t'})
        and $addition{$path}->{'t'} > $mtime){
        $mtime = $addition{$path}->{'t'};
    }
    return $mtime;
}

sub dir_normalization{
}

sub dir_entry{
    my $dir = shift;
    my $opt_s = @_? shift: '';
    my @entry;
    my $dh = new DirHandle($dir);
    if (defined $dh){
        @entry = $dh->read;
        if ($opt_s eq 'n'){
            @entry = map { $_->[0] }
                    sort { $a->[1] cmp $b->[1] } 
                     map { my $tmp = $_;
                           $tmp =~ s/(\d+)/sprintf("%08d", $1)/ge; 
                           [ $_, $tmp ] } @entry;
        }elsif ($opt_s eq 's'){
            @entry = sort @entry;
        }
    }
    return @entry;
}

sub rm_dir{
    for my $arg (@_){
        if (-d $arg){
            for my $entry (&dir_entry($arg)){
                unlink "$arg/$entry";
            }
            rmdir $arg;
        }else{
            unlink $arg;
        }
    }
}

sub unlock{
    $nmzo->remove_tmpdb if defined $nmzo;
    if (defined(my $dh = new DirHandle($index_dir))){
        for my $entry ($dh->read){
            unlink "$index_dir/$entry" if $entry =~ /^NMZ.*tmp$/;
        }
        $dh->close;
    }
    &rm_dir("$tmp_dir/word", "$tmp_dir/phrase");
    rmdir "$tmp_dir/lock";
    &debug::info("Unlocked.");
}

sub term{
    &unlock;
    exit;
}

package userfile;

sub new{
    my $class = shift;
    my $self = {};
    bless $self, $class;

    $self->{'path'} = shift;
    $self->{'fh'} = new IO::File($self->{'path'});
    $self->{'size'} = -s $self->{'path'};
    $self->{'lastword'} = '';
    $self->{'lasttype'} = '';
    $self->{'euc option'} = 'a2a';

    %{$self->{'word'}} = ();
    %{$self->{'phrase'}} = ();

    return undef unless defined($self->{'fh'});
    return $self;
}

sub close{
    my $self = shift;
    my $fileno = $nmzo_flist->{'offset'};

    my %list;
    $list{'t'} = &main::mtime($self->{'path'});
    $list{'r'} = $self->{'path'};

    &debug::info("  field\n");

    for my $field (keys %field){
        my $value = $self->{'field'}->{$field};
        unless (defined $value){
            $value = '';
            $value = $self->{'path'} if $field eq 'uri';
            $value = (stat($self->{'path'}))[7] if $field eq 'size';
            $value = localtime($list{'t'}) . "" if $field eq 'date';
            if ($field eq 'subject'){
                $value = $self->{'path'};
                $value = $1 if $value =~ /([^\/]+)\/?$/;
            }
        }
        $list{'field'}->{$field} = $value;
    }
    $nmzo_flist->write(\%list);

    {
        my $word_total = scalar(keys %{$self->{'word'}});
        my $word_num = 0;
        my $fh;
        my $current_ord = '';
        &debug::info("  word $word_total\n");
        for my $word (sort keys %{$self->{'word'}}){
            my $ord = sprintf("%02X", ord $word);
            if ($current_ord ne $ord){
                $current_ord = $ord;
                $fh = new IO::File (">>$tmp_dir/word/_$ord");
            }
            $fh->printf("%s %04X %04X\n", $word, $fileno, $self->{'word'}->{$word});
            &debug::progress("    $word_num/$word_total\n");
            $word_num++;
        }
        $fh->close if $current_ord ne '';
    }

    {
        my $phrase_total = scalar(keys %{$self->{'phrase'}});
        my $phrase_num = 0;
        my $fh;
        my $current_entry = '';

        &debug::info("  phrase $phrase_total\n");
        for my $hash (sort values %{$self->{'phrase'}}){
            my $entry = substr($hash, 0, 2);
            if ($current_entry ne $entry){
                $current_entry = $entry;
                $fh = new IO::File (">>$tmp_dir/phrase/_$entry");
            }
            $fh->printf("$hash %04X\n", $fileno);
            &debug::progress("    $phrase_num/$phrase_total\n");
            $phrase_num++;
        }
        $fh->close if $current_entry ne '';
    }
    &debug::info("done.\n");
}

sub euc_option{
    my $self = shift;
    $self->{'euc option'} = shift;
}

sub getline{
    my $self = shift;
    my $line = $self->{'fh'}->getline;
    &debug::progress($self->{'fh'}->tell . "/" . $self->{'size'});

    unless (defined $line){
        my $ptr = $addition{$self->{'path'}};
        if (defined $ptr){
            $ptr = $ptr->{'line'};
            $line = @{$ptr}? shift(@{$ptr}): undef;
        }
    }

    if (defined $line){
        $line =~ tr/\t\r/ /d;
        chomp $line if $line =~ /^\S/;
        $line = &main::toEuc($line, 'doc', $self->{'euc option'});
    }
    return $line;
}

sub putfield{
    my $self = shift;
    my $name = shift;
    my $value = shift;

    $name =~ tr/A-Z/a-z/;
    if (defined $field{$name}){
        $name = $field{$name};
        $value =~ tr/\n/ /;
        $self->{'field'}->{$name} .= $value;
        &debug::debug("$name=$value\n");
    }
}

sub putsummary{
    my $self = shift;
    my $name = 'summary';

    if ($summary && defined $field{$name}){
        $name = $field{$name};
        $self->{'field'}->{$name} = '' unless defined $self->{'field'}->{$name};
        if ($summary > length $self->{'field'}->{$name}){
            my $value = shift;
            $value =~ s/^[ \s\t\r\n]+//g;
            $value =~ s/[ \s\t\r\n]+$//g;
            $value =~ s/[ \s\t\r\n]+/ /g;

            if ($self->{'field'}->{$name} =~ /[\x21-\x7f]$/ && $value =~ /^[\x21-\x7e]/){
                $self->{'field'}->{$name} .= ' ';
            }
            $self->{'field'}->{$name} .= $value;
        }
    }
}

sub putword{
    my $self = shift;
    my $word = shift;
    my $weight = shift;
    $weight = 1 unless defined $weight;
    &debug::debug("word: $word\n") unless $self->{'word'}->{$word};
    $self->{'word'}->{$word} += $weight;
}

sub putphrase{
    my $self = shift;
    my $phrase = $_[0] . $_[1];

    unless ($self->{'phrase'}->{$phrase}){
        my $hash = 0;
        my $i = 0;
        while ($phrase =~ m/([\xa1-\xfea-z\d])/g){
            $hash ^= $nmzphrase::Seed[($i++) & 3][ord($1)];
        }
        $hash = sprintf("%04X", $hash & 0xffff);
        &debug::debug("phrase: $hash = $_[0] $_[1]");
        $self->{'phrase'}->{$phrase} = $hash;
    }
}

sub putline{
    my $self = shift;
    my $lref = shift;
    my $weight = shift;

    my $line = $lref;
    $line = $$lref, $$lref = '' if ref $lref;

    while (length $line){
        if ($line =~ s/^($katakana+)//o){
            my $word = $1;
            my $type = 'katakana';
            $self->putword($word, $weight);
            $self->putphrase($self->{'lastword'}, $word) if $self->{'lasttype'} eq $type;
            $self->{'lastword'} = $word;
            $self->{'lasttype'} = $type;
        }elsif ($line =~ s/^($kanji)//o){
            my $word = $1;
            my $type = 'kanji';
            $self->putword($word, $weight);
            $self->putphrase($self->{'lastword'}, $word) if $self->{'lasttype'} eq $type;
            $self->{'lastword'} = $word;
            $self->{'lasttype'} = $type;
        }elsif ($line =~ s/^($hiragana+|\n)//o){
            $self->{'lastword'} = '';
            $self->{'lasttype'} = '';
        }elsif ($line =~ s/^($alnum_word)//io){
            my $words = $1;
            $words =~ tr/A-Z/a-z/;
            while ($words =~ /($alnum+)/go){
                my $word = $1;
                my $type = 'alnum';
                if (length $word < 32){
                    $self->putword($word, $weight);
                    $self->putphrase($self->{'lastword'}, $word) if $self->{'lasttype'} eq $type;
                    $self->{'lastword'} = $word;
                    $self->{'lasttype'} = $type;
                }else{
                    $self->{'lastword'} = '';
                    $self->{'lasttype'} = '';
                }
            }
        }elsif ($line !~ s/^\s+//){
            $line =~ s/^([\xa1-\xfe][\xa1-\xfe]|[^\da-z\xa1-\xfe\n]+)//i;
            $self->{'lastword'} = '';
            $self->{'lasttype'} = '';
        }
    }
}

package debug;

sub info{
    my $str = shift;
    chomp $str;
    print "$str\n";
    $debug::outputtime = time;
}

sub progress{
    return if defined($debug::outputtime) && time - $debug::outputtime < 2;
    my $str = shift;
    chomp $str;
    print "$str\n";
    $debug::outputtime = time;
}

sub debug{
    return unless $DEBUG;
    my $str = shift;
    chomp $str;
    print "$str\n";
    $debug::outputtime = time;
}

sub printenv{
    if ($DEBUG){
        &info("\$0: $0");
        &info("EXECUTABLE_NAME: $^X") if defined $^X;
        &info("OSNAME: $^O");
        &info("PERL_VERSION: $]");
        &info("pnamazu-2006.02.28");
        eval "use Cwd;";
        my $cwd = eval{&getcwd} unless $@;
        &info("Cwd: $cwd") unless $@;
        my $key;
        for $key (@ARGV){
            &info("ARGV: $key");
        }
        for $key (sort keys %ENV){
            &info("Env: $key=$ENV{$key}");
        }
        &ps;
    }
}

sub ps{
    return;
    if ($DEBUG){
        return unless my @ps = `ps uxww`;

        &info($ps[0]);
        my @elem = split(/\s+/, $ps[0]);
        my $ndx = scalar @elem;

        while (--$ndx >= 0){
            last if $elem[$ndx] =~ /^PID$/i;
        }
        shift(@ps);
        for my $ps (@ps){
            &info($ps) if $ndx < 0 || (split(/\s+/, $ps))[$ndx] == $$;
        }
    }
}
