#-------------------------- 'input' Module ---------------------------
sub input::pWakachi{
    my $str = shift;
    # 1byte - 2byte ʬ
    $str =~ s/([\x21-\x7f])([\x80-\xff])/$1 $2/g;
    # 2byte - 1byte ʬ
    $str =~ s/([\x80-\xff])([\x21-\x7f])/$1 $2/g;
    return $str;
}

sub string_normalize{
    my $pat;
    my $str = &toEuc(shift, 'a2a');
    $str =~ s/^\s+//;
    while ($str !~ /^$/){
        $pat .= "$1 ", next if $str =~ s/^([\{\(\"])\s*//; #"

        if ($str =~ s/^((\+[^\s\:]+\:)?([\/\"]))//){ #"
            my $tmp = $1;
            my $ch = $3;
            $tmp =~ tr/A-Z/a-z/;
            $pat .= $tmp;

            $str =~ s/^((\\.|[^$ch])*)//;
            $tmp = "$1$ch";
            $str =~ s/^$ch\s*//;
            $tmp =~ s/\s/\xa0/g;
                                       
            $pat .= "$tmp ";
            next;
        }

        $pat .= "$1 ", next if $str =~ s/^(\+[^\s\:]+\:\S+)\s*//;

        if ($str =~ s/^(\S+)\s*//){
            my($tmp) = $1;
            my $p = ($tmp =~ s/([\"\}\)])$//)? " $1": ''; #"
            my $f = ($tmp =~ s/(\*)$//)? $1: '';
            my $b = ($tmp =~ s/^(\*)//)? $1: '';

            $tmp =~ s/([\x21-\x7f])([\x80-\xff])/$1 $2/g;
            $tmp =~ s/([\x80-\xff])([\x21-\x7f])/$1 $2/g;
            $tmp =~ tr/A-Z/a-z/;
            $pat .= "$b$tmp$f$p ";
        }
    }
    $pat =~ s/\s+/ /g;
    $pat =~ s/^\s+//;
    $pat =~ s/\s+$//;
    $pat;
}
1;
#----------------------- End of 'input' Module -----------------------
