#-------------------------- 'output' Module --------------------------
sub meta_http_equiv{
    my ($he, $content) = @_;
    $he =~ tr/A-Z/a-z/ if $Xht;
    &output("<meta http-equiv=\"$he\" content=\"$content\"$Xht>\n");
}

sub lang_exp{
    my $code = &get_output_ja_code;
    &meta_http_equiv("Content-Type", "text/html; charset=$code");
    &output("<!-- \xf3\xfe -->\n");
}

sub output{
    # ǡνϤ˻ȤϤ ISO-2022-JP ޤ EUC-JP Ȳꡣ
    my(@list) = @_;
    my($tmp, $str);
    my $ojcode = &get_output_ja_code;
    foreach $str (@list){
        $str = &html2plain($str) if $PlainConv;
        $str = &x0208_to_x0201kana($str) if $Phone && $PhoneX0201;
        $str = &output_code($str);
        &prn($str);
    }
}

sub message{
    # ץʸνϤ˻Ȥ
    &output(&toEuc(shift)) while @_;
}


my $prn_buf = '';
sub prn_proc{
    $prn_buf .= join('', @_);
    if (defined(&print)){
        while ((my $index = index($prn_buf, "\n")) >= 0){
            local $_ = substr($prn_buf, 0, $index + 1);
            &print($_);
            substr($prn_buf, 0, $index + 1) = '';
        }
    }else{
        print $prn_buf;
        $prn_buf = '';
    }
}

sub prn{
    if ($Lucky){
        $prn_buf .= join('', @_);
    }else{
        &prn_proc(@_);
    }
}

sub prn_flash{
    if ($LuckyURI){
        &prn_proc() if $Debug > 0;
        $prn_buf = "Location: $LuckyURI\n\n";
    }
    &prn_proc();
    if (defined(&print)){
        &print($prn_buf) if length $prn_buf;
        &print(undef);
    }
}

1;
#---------------------- End of 'output' Module -----------------------
