#-------------------- 'regular expression' Module --------------------
$REG = 1;

sub reg_search{
    local($origkey, *score, $_) = @_;
    s/\xa0/ /g;
    local($match, $flag) = ($_, 1);
    my %opt = ('ex' => 1, 'case' => 0, 'ff' => 1);
    my $pat = &regconv(\$match, \%opt);
    my $flag = $opt{'MB'};
    my $fh = $flag? 'MB': 'SB';
    my $fhi = $fh . 'INDEX';
    my($db, $totalhit) = ("$DbPath.w", 0);
    local(*FW, $x, $_);
    $match = "/$match/";

    eval("/$pat/i");
    s/[\r\n]//g, s/ at .*//, push(@DbErrors, "$match $_"), return ($match, '', 0) if $_ = $@;

    if ($CACHE){
        &cache_init;
        $totalhit = &cache_read_word("reg $pat", *score, $match, $pat, $flag);
        return ($match, '', $totalhit) if $totalhit >= 0;
    }

    $totalhit = 0;
    my $direct = ($DbSize{'WORD'} && !$WORD);
    my $ndx = 0;
    my $wordcnt = 0;
    my @ndx;
    seek('WORD', 0, 0) if $direct;

    my $searchstr = "while (\$ndx < \$DbNdx{'INDEXINDEX'}){";
    $searchstr .= "my \$str = \$direct? <WORD>: &readindexindex(\$ndx);";
    $searchstr .= "chomp \$str;";
    $searchstr .= "\$str =~ s/([\xa1-\xfe][\xa1-\xfe])/\xff\$1/g if \$flag;";
    $searchstr .= "if (\$str =~ /$pat/i){";
    $searchstr .= " &ssub(\\\$totalhit, \$ndx, *score, \$match, \$pat, \$flag);";
    $searchstr .= "\%score = () if \$totalhit >= \$MaxHit;" if $MaxHit;
    $searchstr .= "undef %{\$SubHit{\$match}}, last if ++\$wordcnt >= \$MaxMatch;" if $MaxMatch;
    $searchstr .= "push(\@ndx, \$ndx);" if $CACHE;
    $searchstr .= "}";
    $searchstr .= "\$ndx++;";
    $searchstr .= "}";
    eval $searchstr;
    if ($MaxHit && $totalhit >= $MaxHit){
        $totalhit = 0;
        %score = ('TooMany' => 'Too many document hits. Ignored');
    }elsif ($MaxMatch && $wordcnt >= $MaxMatch){
        $totalhit = 0;
        %score = ('TooMany' => 'Too many words match. Ignored');
    }else{
        &cache_write_word("reg $pat", @ndx) if $CACHE && @ndx;
    }
    return ($match, '', $totalhit);
}
1;
#----------------- End of 'regular expression' Module ----------------
